@echo on
@rem
@rem Compliles HJ then compiles Java. See if generated Java is OK
@rem

@title Build Sample

@set CLASSPATH=..\lib\HybridJava.jar;..\lib\HybridJava_rt.jar;..\lib\servlet-2_3-fcs-classfiles.zip;classes
@set HybridDelim=  =========  
@set J=%JAVA_HOME%\bin\javac.exe -Xmaxerrs 5 -g -d classes -target 1.5
@set P=com\HybridJava\Sample
@set P_LIB=com\HybridJava\Lib
@if not exist classes @mkdir classes

@rmdir /Q/S gen\com
@rmdir /Q/S classes\com

@set 					T=COMPILE JAVA SOURCES
rem %HybridDelim% %T%

@if exist pojos\%P%\*.java     		%J% pojos\%P%\*.java
@if errorlevel 1 goto :error
@if exist pages\%P%\*_PS.java		%J% pages\%P%\*_PS.java
@if errorlevel 1 goto :error
@if exist widgets\%P%\*_WS.java		%J% widgets\%P%\*_WS.java
@if errorlevel 1 goto :error
@if exist widgets\%P_LIB%\*_WS.java	%J% widgets\%P_LIB%\*_WS.java
@if errorlevel 1 goto :error

@set 					T=GENERATE PAGES JAVA SOURCE
rem %HybridDelim% %T%
%JAVA_HOME%\bin\java.exe -ea com.HybridServerPages.Main -verbose
@if errorlevel 1 goto :error

@set 					T=COMPILE GENERATED JAVA
rem %HybridDelim% %T%
%J% -Xlint:deprecation gen\%P%\*.java servlet\%P%\SimpleServlet.java
@if errorlevel 1 goto :error

@set 					T=CREATE WAR DIRECTORY
rem %HybridDelim% %T%

    @rmdir /S /Q war
    @mkdir war
    @mkdir war\images
    @mkdir war\WEB-INF
    @mkdir war\WEB-INF\lib
    @mkdir war\WEB-INF\classes
    @copy web.xml war\WEB-INF\
    @xcopy /Q /S ..\lib\HybridJava_rt.jar war\WEB-INF\lib\
    @xcopy /Q /S classes\*.class war\WEB-INF\classes\
    @xcopy /Q /S images\* war\images\ 

@set 					T=CREATE WAR FILE for PC
rem %HybridDelim% %T%

@pushd war
%JAVA_HOME%\bin\jar.exe -cMf ..\PC.war *
@rem PC.war may be deployed on PC

@set 					T=CREATE classes.zip FILE
rem %HybridDelim% %T%

@pushd WEB-INF
@pushd classes
 
@del ..\lib\TMP.jar
%JAVA_HOME%\bin\jar.exe -cMf ..\lib\TMP.jar *

@popd
@pushd lib

%JAVA_HOME%\bin\java -Xmx1024M -jar "%ANDROID_TOOLS%"\lib\dx.jar --dex --output=classes.zip TMP.jar HybridJava_rt.jar
@popd
@popd

@set 					T=CREATE WAR FILE for ANDROID
rem %HybridDelim% %T%

%JAVA_HOME%\bin\jar.exe -cMf ..\HJ.war images WEB-INF\lib\classes.zip WEB-INF\web.xml

@rem popd from war/
@popd
@pause Build.bat done
exit
:error
@echo Build.bat failed
@pause